<?php
if( !defined( '_VALID_MOS' ) && !defined( '_JEXEC' ) ) die( 'Direct Access to '.basename(__FILE__).' is not allowed.' );
/*
* Updated: Alex Estrada, PayJunction
* Date: April 8, 2010
* File: payjunction.php
* Description: Implementation of the Trinity Gateway Service API v1.2 in PHP for VirtueMart.
* 

--Protecting your Website and Payment Applications from Man-In-The-Middle-Attacks--
Our API allows merchants and developers to connect to PayJunction via an encrypted SSL communications link. In order for your website or payment application to verify that your connection to PayJunction has not been intercepted, all code that connects to PayJunction must verify then authenticity of our SSL certificate by performing strict server certificate verification against PayJunction's root certificate authority. It has come to our attention that some merchants have disabled the SSL certificate verification for testing purpose; while the SSL connection remains secure, it is possible that an attacker could try to initiate a Man-In-The-Middle attack in an attempt to intercept your website's or applications connection to PayJunction.

Common Mistake: Anyone website or application that does not verify the authenticity of PayJunction's SSL certificate upon connecting to our QuickLink API.

Solution: Turn SSL verification on prior to connecting to PayJunction for transaction authorizations. In the event that your website is unable to verify the authenticity of PayJunction's root certificate, your website and/or application should not transmit any transaction information and should reject your customer's transactions. If you believe your application is unable to verify the authenticity of PayJunction's certificate, contact our support department.

--PayJunction Security Requirements and Best Practices for Merchants and Developers--
https://www.payjunction.com/trinity/support/view.action?knowledgeBase.knbKnowledgeBaseId=451

--Please note--
There is no warranty for the programs or example code provided in PayJunction's support center. The copyright holders and/or other parties provide the program "as is" without warranty of any kind, either expressed or implied, including, but not limited to, the implied warranties of merchantability and fitness for a particular purpose. The entire risk as to the quality and performance of the program is with you. Should the program prove defective, you assume the cost of all necessary servicing, repair or correction. It is the merchant's responsibility to ensure their systems meet the PCI requirements. PayJunction's Gateway Agreement have been updated to include the referenced "PayJunction Security Requirements and Best Practices for Merchants and Developers;" it is the merchant's responsibility to review this knowledge base on a regular basis for the security of the merchant's account and to protect cardholder data.

Please contact us if you have any questions.

With Kindest Regards,
The PayJunction Team
support@payjunction.com

********************************************/

/********************************************
The ps_payjunction class, containing the payment processing code for transactions with PayJunction 

@version $Id: ps_payjunction.php 1095 2007-12-19 20:19:16Z soeren_nb $
@package VirtueMart
@subpackage payment
@copyright Copyright (C) 2004-2007 soeren - All rights reserved.
@license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
VirtueMart is free software. This version may have been modified pursuant to the GNU General Public License, and as distributed it includes or is derivative of works licensed under the GNU General Public License or other free or open source software licenses.

See /administrator/components/com_virtuemart/COPYRIGHT.php for copyright notices and details.

http://virtuemart.net
********************************************/

class ps_payjunction {

	var $payment_code = "PJ";
	var $classname = "ps_payjunction";

	/**
    * Show all configuration parameters for this payment method
    * @returns boolean False when the Payment method has no configration
    */
	function show_configuration() {

		global $VM_LANG, $sess;
		$db =& new ps_DB;
		$payment_method_id = vmGet( $_REQUEST, 'payment_method_id', null );
		/** Read current Configuration ***/
		require_once(CLASSPATH ."payment/".$this->classname.".cfg.php");
    ?>
      <table>
        <tr>
            <td><strong>PayJunction Username</strong></td>
            <td>
                <input type="text" name="PJ_LOGON" class="inputbox" value="<?php echo PJ_LOGON ?>" />
            </td>
            <td>This your PayJunction logon identifying your account
            </td>
        </tr>
        <tr>
            <td><strong>PayJunction Password</strong></td>
            <td>
                <input type="text" name="PJ_PASSWORD" class="inputbox" value="<?php echo PJ_PASSWORD ?>" />
            </td>
        </tr>
        <tr>
            <td><strong>Capture CVV Code</strong></td>
            <td>
                <select name="PJ_CHECK_CARD_CODE" class="inputbox">
                <option <?php if (PJ_CHECK_CARD_CODE == 'YES') echo "selected=\"selected\""; ?> value="YES">Yes</option>
                <option <?php if (PJ_CHECK_CARD_CODE == 'NO') echo "selected=\"selected\""; ?> value="NO">No</option>
                </select>
            </td>
            <td><?php echo $VM_LANG->_PHPSHOP_PAYMENT_CVV2_TOOLTIP ?></td>
        </tr>
        <tr>
            <td><strong>Require Address Verfication System (AVS)</strong></td>
            <td>
                <select name="PJ_AVS" class="inputbox">
                <option <?php if (PJ_AVS == 'AWZ') echo "selected=\"selected\""; ?> value="AWZ">
                Match Address or Zip</option>
                <option <?php if (PJ_AVS == 'XY') echo "selected=\"selected\""; ?> value="XY">
                Match Address and Zip</option>
                <option <?php if (PJ_AVS == 'WZ') echo "selected=\"selected\""; ?> value="WZ">
                Match Zip</option>
                <option <?php if (PJ_AVS == 'AW') echo "selected=\"selected\""; ?> value="A">
                Match Address</option>
                <option <?php if (PJ_AVS == 'OFF') echo "selected=\"selected\""; ?> value="OFF">
                Disabled</option>
                </select>
            </td>
            <td>Use the Address Verfication System (AVS) to verify identity of the user.</td>
        </tr> 
        <tr>
            <td><strong>Authentication Type</strong></td>
            <td>
               <select name="PJ_TYPE" class="inputbox">
                <option <?php if (PJ_TYPE == 'AUTHORIZATION_CAPTURE') echo "selected=\"selected\""; ?> value="AUTHORIZATION_CAPTURE">Authorization Capture</option>
                <option <?php if (PJ_TYPE == 'AUTHORIZATION') echo "selected=\"selected\""; ?> value="AUTHORIZATION">Authorization Only</option>
               </select>
            </td>
            <td>Authorization Only will set aside funds to be withdrawn; Authorization Capture will withdraw the funds immediately.  <strong>NOTE:</strong> Authorization Only is only supported if you are using the advanced verison of the PayJunction module.  If you are using the basic version use Authorization Capture.  See the README for more details.
            </td>
        </tr>
        <tr><td colspan="3"><hr/></td></tr>
        <tr>
            <td><strong>Order Status for successful transactions</strong></td>
            <td>
                <select name="PJ_VERIFIED_STATUS" class="inputbox" >
                <?php
                $q = "SELECT order_status_name,order_status_code FROM #__{vm}_order_status ORDER BY list_order";
                $db->query($q);
                $order_status_code = Array();
                $order_status_name = Array();

                while ($db->next_record()) {
                	$order_status_code[] = $db->f("order_status_code");
                	$order_status_name[] =  $db->f("order_status_name");
                }
                for ($i = 0; $i < sizeof($order_status_code); $i++) {
                	echo "<option value=\"" . $order_status_code[$i];
                	if (PJ_VERIFIED_STATUS == $order_status_code[$i])
                	echo "\" selected=\"selected\">";
                	else
                	echo "\">";
                	echo $order_status_name[$i] . "</option>\n";
                    }?>
                    </select>
            </td>
            <td>Select the order status to which the actual order is set, if the PayJunction Transaction was successful. 
            If using download selling options: select the status which enables the download (then the customer is instantly notified about the download via e-mail).
            </td>
        </tr>
            <tr>
            <td><strong>Order Status for failed transactions</strong></td>
            <td>
                <select name="PJ_INVALID_STATUS" class="inputbox" >
                <?php
                for ($i = 0; $i < sizeof($order_status_code); $i++) {
                	echo "<option value=\"" . $order_status_code[$i];
                	if (PJ_INVALID_STATUS == $order_status_code[$i])
                	echo "\" selected=\"selected\">";
                	else
                	echo "\">";
                	echo $order_status_name[$i] . "</option>\n";
                    } ?>
                    </select>
            </td>
            <td>Select an order status for failed PayJunction transactions.</td>
        </tr>

            <tr>
            <td><strong>Show Response Codes for Failed Transactions?</strong></td>
            <td>
                <select name="PJ_SHOW_ERROR_CODE" class="inputbox">
                <option <?php if (PJ_SHOW_ERROR_CODE == 'YES') echo "selected=\"selected\""; ?> value="YES">Yes</option>
                <option <?php if (PJ_SHOW_ERROR_CODE == 'NO') echo "selected=\"selected\""; ?> value="NO">No</option>
                </select>
            </td>
            <td>If set to YES then the customer will see the PayJunction transaction response code and message.  This can be useful for troubleshooting failed or declined transactions.</td>
        </tr>
        <tr>
            <td><strong>Automatically refund order when order status is changed to "refunded"?</strong></td>
            <td>
                <select name="PJ_INSTANT_REFUND" class="inputbox">
                <option <?php if (PJ_INSTANT_REFUND == 'YES') echo "selected=\"selected\""; ?> value="YES">Yes</option>
                <option <?php if (PJ_INSTANT_REFUND == 'NO') echo "selected=\"selected\""; ?> value="NO">No</option>
                </select>
            </td>
            <td>If set to YES then the customer will be refunded when the order status is changed to "refunded".</td>
        </tr>
      </table>
   <?php
   // return false if there's no configuration
   return true;
	}

	function has_configuration() {
		// return false if there's no configuration
		return true;
	}

	/**
	* Returns the "is_writeable" status of the configuration file
	* @param void
	* @returns boolean True when the configuration file is writeable, false when not
	*/
	function configfile_writeable() {
		return is_writeable( CLASSPATH."payment/".$this->classname.".cfg.php" );
	}

	/**
	* Returns the "is_readable" status of the configuration file
	* @param void
	* @returns boolean True when the configuration file is writeable, false when not
	*/
	function configfile_readable() {
		return is_readable( CLASSPATH."payment/".$this->classname.".cfg.php" );
	}
	/**
	* Writes the configuration file for this payment method
	* @param array An array of objects
	* @returns boolean True when writing was successful
	*/
	function write_configuration( &$d ) {

		$my_config_array = array(
		"PJ_LOGON" => $d['PJ_LOGON'],
		"PJ_PASSWORD" => $d['PJ_PASSWORD'],
		"PJ_TYPE" => $d['PJ_TYPE'],
		"PJ_CHECK_CARD_CODE" => $d['PJ_CHECK_CARD_CODE'],
		"PJ_AVS" => $d['PJ_AVS'],
		"PJ_VERIFIED_STATUS" => $d['PJ_VERIFIED_STATUS'],
		"PJ_INVALID_STATUS" => $d['PJ_INVALID_STATUS'],
		"PJ_INSTANT_REFUND" => $d['PJ_INSTANT_REFUND'], 
		"PJ_SHOW_ERROR_CODE" => $d['PJ_SHOW_ERROR_CODE']
		);
		$config = "<?php\n";
		$config .= "if( !defined( '_VALID_MOS' ) && !defined( '_JEXEC' ) ) die( 'Direct Access to '.basename(__FILE__).' is not allowed.' ); \n\n";
		foreach( $my_config_array as $key => $value ) {
			$config .= "define ('$key', '$value');\n";
		}

		$config .= "?>";

		if ($fp = fopen(CLASSPATH ."payment/".$this->classname.".cfg.php", "w")) {
			fputs($fp, $config, strlen($config));
			fclose ($fp);
			return true;
		}
		else {
			return false;
		}
	}

	/**************************************************************************
	** name: process_payment()
	** created by: Soeren
	** modified by: Alex Estrada, PayJunction, Inc.
	** description: process transaction with PayJunction
	** parameters: $order_number, the number of the order, we're processing here
	**            $order_total, the total $ of the order
	** returns:
	***************************************************************************/
	function process_payment($order_number, $order_total, &$d) {

		global $vendor_mail, $vendor_currency, $VM_LANG, $vmLogger;
		$database = new ps_DB;
		$ps_vendor_id = $_SESSION["ps_vendor_id"];
		$auth = $_SESSION['auth'];
		$ps_checkout = new ps_checkout;

		// Get the Configuration File for PayJunction
		require_once(CLASSPATH ."payment/".$this->classname.".cfg.php");
		// connector class
		require_once(CLASSPATH ."connectionTools.class.php");

		// Get user billing information
		$dbbt = new ps_DB;

		$qt = "SELECT * FROM #__{vm}_user_info WHERE user_id=".$auth["user_id"]." AND address_type='BT'";

		$dbbt->query($qt);
		$dbbt->next_record();
		$user_info_id = $dbbt->f("user_info_id");
		if( $user_info_id != $d["ship_to_info_id"]) {
			// Get user billing information
			$dbst =& new ps_DB;
			$qt = "SELECT * FROM #__{vm}_user_info WHERE user_info_id='".$d["ship_to_info_id"]."' AND address_type='ST'";
			$dbst->query($qt);
			$dbst->next_record();
		}
		else {
			$dbst = $dbbt;
		}
		$host = 'www.payjunction.com';
		$port = 443;
		$path = "/quick_link";
		// Option to send email to merchant from gateway
		if (AN_EMAIL_MERCHANT == 'NO') {
				$vendor_mail = "";
 		}
		if (AN_EMAIL_CUSTOMER == 'YES') {
			$email_customer = "TRUE";
		} else {
			$email_customer = "FALSE";
 		}
 		// Setup dc_security string
 		if(PJ_CHECK_CARD_CODE=='YES') {
 			$cvv = 'M';
 		} else {
 			$cvv = 'I';
 		}
 		if(PJ_AVS=='OFF') {
 			$dc_security = "AWZ|$cvv|false|true|false";
 		} else {
 			$dc_security = PJ_AVS."|$cvv|false|false|false";
 		}

		//Setup Keys and Values
		$formdata = array (
		'dc_logon' => PJ_LOGON,
		'dc_password' => PJ_PASSWORD,
		'dc_version' => '1.2',
		'dc_security' => $dc_security,

		// Customer Name and Billing Address
		'dc_company' => substr($dbbt->f("company"), 0, 50),
		'dc_address' => substr($dbbt->f("address_1"), 0, 60),
		'dc_city' => substr($dbbt->f("city"), 0, 40),
		'dc_state' => substr($dbbt->f("state"), 0, 40),
		'dc_zipcode' => substr($dbbt->f("zip"), 0, 20),
		'dc_country' => substr($dbbt->f("country"), 0, 60),
		'dc_phone' => substr($dbbt->f("phone_1"), 0, 25),
		'dc_fax' => substr($dbbt->f("fax"), 0, 25),

		// Customer Shipping Address
		'dc_shipping_first_name' => substr($dbst->f("first_name"), 0, 50),
		'dc_shipping_last_name' => substr($dbst->f("last_name"), 0, 50),
		'dc_shipping_company' => substr($dbst->f("company"), 0, 50),
		'dc_shipping_address' => substr($dbst->f("address_1"), 0, 60),
		'dc_shipping_city' => substr($dbst->f("city"), 0, 40),
		'dc_shipping_state' => substr($dbst->f("state"), 0, 40),
		'dc_shipping_zip' => substr($dbst->f("zip"), 0, 20),
		'dc_shipping_country' => substr($dbst->f("country"), 0, 60),

		// Invoice Information
		'dc_invoice_number' => substr($order_number, 0, 20),
		'dc_notes' => $VM_LANG->_PHPSHOP_ORDER_PRINT_PO_LBL,

		// Transaction Data
		'dc_transaction_amount' => $order_total-substr($d['order_tax'], 0, 15)-$d['order_shipping'],
		'dc_transaction_type' => PJ_TYPE,

		'dc_number' => $_SESSION['ccdata']['order_payment_number'],
		'dc_name' => $_SESSION['ccdata']['order_payment_name'],
		'dc_verification_number' => $_SESSION['ccdata']['credit_card_code'],
		'dc_expiration_month' => ($_SESSION['ccdata']['order_payment_expire_month']),
		'dc_expiration_year' => ($_SESSION['ccdata']['order_payment_expire_year']),

		// Level 2 data
		'dc_tax_amount' => substr($d['order_tax'], 0, 15),
		'dc_shipping_amount' => $d['order_shipping']
		);

		//build the post string
		$poststring = '';
		foreach($formdata AS $key => $val){
			$poststring .= urlencode($key) . "=" . urlencode($val) . "&";
		}
		// strip off trailing ampersand
		$poststring = substr($poststring, 0, -1);
		
		if( function_exists( "curl_init" )) {
			
			$vmLogger->debug( 'Using the cURL library for communicating with '.$host );

			$CR = curl_init();
			curl_setopt($CR, CURLOPT_URL, "https://".$host.$path);
			curl_setopt($CR, CURLOPT_SSL_VERIFYPEER, 1);
			curl_setopt($CR, CURLOPT_SSL_VERIFYHOST, 2);
			curl_setopt($CR, CURLOPT_POST, 1);
			curl_setopt($CR, CURLOPT_POSTFIELDS, $poststring);
			curl_setopt($CR, CURLOPT_FOLLOWLOCATION, 0);
			curl_setopt($CR, CURLOPT_RETURNTRANSFER, 1);
			curl_setopt($CR, CURLOPT_FAILONERROR, true);

			$result = curl_exec( $CR );

			$error = curl_error( $CR );
			if( !empty( $error )) {
				$vmLogger->err( $error );
				$html = "<br/><span class=\"message\">".$VM_LANG->_PHPSHOP_PAYMENT_INTERNAL_ERROR." PayJunction.com</span>";
				return false;
			}
			else {
				//echo $result; exit();
			}
			curl_close( $CR );
		}
		else {
			$vmLogger->debug( 'Starting communication with '.$host.' without cURL library.');

			$fp = fsockopen("ssl://".$host, $port, $errno, $errstr, $timeout = 60);
			if(!$fp){
				//error tell us
				$vmLogger->err( "Possible server error! - $errstr ($errno)\n" );
			}
			else {
				$vmLogger->debug( 'Connection opened to '.$host.', now posting the variables.');

				//send the server request
				fputs($fp, "POST $path HTTP/1.1\r\n");
				fputs($fp, "Host: $host\r\n");
				fputs($fp, "Content-type: application/x-www-form-urlencoded\r\n");
				fputs($fp, "Content-length: ".strlen($poststring)."\r\n");
				fputs($fp, "Connection: close\r\n\r\n");
				fputs($fp, $poststring . "\r\n\r\n");

				//Get the response header from the server
				$str = '';
				while(!feof($fp) && !stristr($str, 'content-length')) {
					$str = fgets($fp, 4096);
				}
				// If didnt get content-length, something is wrong, return false.
				if (!stristr($str, 'content-length')) {
					$vmLogger->err('An error occured while communicating with the PayJunction server. It didn\'t reply (correctly). Please try again later, thank you.' );
					return false;
				}
				$data = "";
				while (!feof($fp)) {
					$data .= fgets ($fp, 1024);
				}
				$result = trim( $data );
                        }
                }
                // Parse the response from PayJunction
                $content = explode(chr(28), $result);
                foreach($content as $key_value) {
                	list($key,$value) = explode('=', $key_value);
                	$response[$key] = $value;
                }
                                
                $vmLogger->debug('Beginning to analyse the response from '.$host);
		
		// Approved - Success!
		if ($response['dc_response_code'] == '00' || $response['dc_response_code'] == '85') {
			$d["order_payment_log"] = $VM_LANG->_PHPSHOP_PAYMENT_TRANSACTION_SUCCESS.": ".$response['dc_response_code'];

			$vmLogger->debug( $d['order_payment_log']);

			// Catch Transaction ID
			$d["order_payment_trans_id"] = $response['dc_transaction_id'];

			return True;
		}
		// Payment Declined
		else if ($response['dc_response_code']) {
			if (PJ_SHOW_ERROR_CODE == 'YES') {
				$vmLogger->err( $response['dc_response_code']."- ". $response['dc_response_message']);
		   	} else {
           			$vmLogger->err($response['dc_response_message']);
			}

			$d["order_payment_log"] = $response['dc_response_message'];
			// Catch Transaction ID
			$d["order_payment_trans_id"] = $response['dc_transaction_id'];
			return False;
		}
	}

	/**************************************************************************
	** name: capture_payment()
	** created by: Soeren
	** modified by: Alex Estrada, PayJunction, Inc.
	** description: Process a previous transaction with PayJunction, Capture the Payment
	** parameters: $order_number, the number of the order, we're processing here
	** returns:
	***************************************************************************/
	function capture_payment( &$d ) {

		global $vendor_mail, $vendor_currency, $VM_LANG, $vmLogger;
		$database = new ps_DB();

		if( empty($d['order_number'])) {
			$vmLogger->err("Error: No Order Number provided.");
			return false;
		}
		/*** Get the Configuration File for PayJunction ***/
		require_once(CLASSPATH ."payment/".$this->classname.".cfg.php");
		
		$host = 'www.payjunction.com';
		$port = 443;
		$path = "/quick_link";
		
		$db = new ps_DB;
		$q = "SELECT * FROM #__{vm}_orders, #__{vm}_order_payment WHERE ";
		$q .= "order_number='".$d['order_number']."' ";
		$q .= "AND #__{vm}_orders.order_id=#__{vm}_order_payment.order_id";
		$db->query( $q );
		if( !$db->next_record() ) {
			$vmLogger->err("Error: Order not found.");
			return false;
		}
		$expire_month = date( "m", $db->f("order_payment_expire") );
		$expire_year = date( "y", $db->f("order_payment_expire") );

		// DECODE Account Number
		$dbaccount = new ps_DB;
		$q = "SELECT DECODE(order_payment_number,'".ENCODE_KEY."')
          AS account_number from #__{vm}_order_payment WHERE order_id='".$db->f("order_id")."'";
		$dbaccount->query($q);
		$dbaccount->next_record();

		// Get user billing information
		$dbbt = new ps_DB;
		$qt = "SELECT * FROM #__{vm}_user_info WHERE user_id='".$db->f("user_id")."'";
		$dbbt->query($qt);
                $dbbt->next_record();
                $user_info_id = $dbbt->f("user_info_id");
                if( $user_info_id != $db->f("user_info_id")) {
                        // Get user's alternative shipping information
                        $dbst =& new ps_DB;
                        $qt = "SELECT * FROM #__{vm}_user_info WHERE user_info_id='".$db->f("user_info_id")."' AND address_type='ST'";
                        $dbst->query($qt);
			$dbst->next_record();
		}
		else {
			$dbst = $dbbt;
		}

		//PayJunction vars to send
		$formdata = array (
		'dc_logon' => PJ_LOGON,
		'dc_password' => PJ_PASSWORD,
		'dc_version' => '1.2',
		'dc_posture' => 'capture',
		'dc_transaction_type' => 'update',
		'dc_transaction_id' => $db->f("order_payment_trans_id"),
		);

		//build the post string
		$poststring = '';
		foreach($formdata as $key => $val){
			$poststring .= urlencode($key) . "=" . urlencode($val) . "&";
		}
		// strip off trailing ampersand
		$poststring = substr($poststring, 0, -1);
		
		if( function_exists( "curl_init" )) {

			$CR = curl_init();
			curl_setopt($CR, CURLOPT_URL, "https://".$host.$path);
			curl_setopt($CR, CURLOPT_SSL_VERIFYPEER, 1);
			curl_setopt($CR, CURLOPT_SSL_VERIFYHOST, 2);
			curl_setopt($CR, CURLOPT_POST, 1);
			curl_setopt($CR, CURLOPT_POSTFIELDS, $poststring);
			curl_setopt($CR, CURLOPT_FOLLOWLOCATION, 0);
			curl_setopt($CR, CURLOPT_RETURNTRANSFER, 1);
			curl_setopt($CR, CURLOPT_FAILONERROR, true);

			$result = curl_exec( $CR );

			$error = curl_error( $CR );
			if( !empty( $error )) {
				$vmLogger->err( curl_error( $CR ) );
				$html = "<br/><span class=\"message\">".$VM_LANG->_PHPSHOP_PAYMENT_INTERNAL_ERROR." PayJunction.com</span>";
				return false;
			}
			else {
				//echo $result; exit();
			}
			curl_close( $CR );
		}
		else {

			$fp = fsockopen("ssl://".$host, $port, $errno, $errstr, $timeout = 60);
			if(!$fp){
				//error tell us
				$vmLogger->err("$errstr ($errno)");
			}
			else {

				//send the server request
				fputs($fp, "POST $path HTTP/1.1\r\n");
				fputs($fp, "Host: $host\r\n");
				fputs($fp, "Content-type: application/x-www-form-urlencoded\r\n");
				fputs($fp, "Content-length: ".strlen($poststring)."\r\n");
				fputs($fp, "Connection: close\r\n\r\n");
				fputs($fp, $poststring . "\r\n\r\n");

				//Get the response header from the server
				$str = '';
				while(!feof($fp) && !stristr($str, 'content-length')) {
					$str = fgets($fp, 4096);
				}
				// If didnt get content-lenght, something is wrong, return false.
				if (!stristr($str, 'content-length')) {
					return false;

				}
				$data = "";
				while (!feof($fp)) {
					$data .= fgets ($fp, 1024);
				}
				$result = trim( $data );
			}
		}
	
		// Parse the response from PayJunction
                $content = explode(chr(28), $result);
                foreach($content as $key_value) {
                	list($key,$value) = explode('=', $key_value);
                	$response[$key] = $value;
                }
                                
                $vmLogger->debug('Beginning to analyse the response from '.$host);

		// Approved - Success!
		if ($response['dc_query_status'] == 'true' && $response['dc_posture'] == 'capture') {
			$d["order_payment_log"] = $VM_LANG->_PHPSHOP_PAYMENT_TRANSACTION_SUCCESS.": ".$response['dc_response_code'];

			$vmLogger->debug( $d['order_payment_log']);

			// Catch Transaction ID
			$d["order_payment_trans_id"] = $response['dc_transaction_id'];

			return True;
		}
		// Payment Declined
		else if ($response['dc_query_status']) {
			if (PJ_SHOW_ERROR_CODE == 'YES') {
				$vmLogger->err('Could not update status.  Status is currently set to '.$reponse['dc_posture']);
		   	} else {
           			$vmLogger->err('Could not update status.  Status is currently set to '.$reponse['dc_posture']);
			}

			$d["order_payment_log"] = $response['dc_response_message'];
			// Catch Transaction ID
			$d["order_payment_trans_id"] = $response['dc_transaction_id'];
			return False;
		}
	}
	/**************************************************************************
	** name: void_authorization()
	** created by: Soeren
	** modified by: Alex Estrada, PayJunction, Inc.
	** description: Process a previous transaction with PayJunction, Void the Payment
	** parameters: $order_number, the number of the order, we're processing here
	** returns:
	***************************************************************************/
	function void_authorization( &$d ) {
	
		global $vendor_mail, $vendor_currency, $VM_LANG, $vmLogger;
		$database = new ps_DB();

		if( empty($d['order_number'])) {
			$vmLogger->err("Error: No Order Number provided.");
			return false;
		}
		/*** Get the Configuration File for PayJunction ***/
		require_once(CLASSPATH ."payment/".$this->classname.".cfg.php");

		$host = 'www.payjunction.com';
		$port = 443;
		$path = "/quick_link";
		
		$db = new ps_DB;
		$q = "SELECT * FROM #__{vm}_orders, #__{vm}_order_payment WHERE ";
		$q .= "order_number='".$d['order_number']."' ";
		$q .= "AND #__{vm}_orders.order_id=#__{vm}_order_payment.order_id";
		$db->query( $q );
		if( !$db->next_record() ) {
			$vmLogger->err("Error: Order not found.");
			return false;
		}
		$expire_month = date( "m", $db->f("order_payment_expire") );
		$expire_year = date( "y", $db->f("order_payment_expire") );

		// DECODE Account Number
		$dbaccount = new ps_DB;
		$q = "SELECT DECODE(order_payment_number,'".ENCODE_KEY."')
          AS account_number from #__{vm}_order_payment WHERE order_id='".$db->f("order_id")."'";
		$dbaccount->query($q);
		$dbaccount->next_record();

		// Get user billing information
		$dbbt = new ps_DB;
		$qt = "SELECT * FROM #__{vm}_user_info WHERE user_id='".$db->f("user_id")."'";
		$dbbt->query($qt);
                $dbbt->next_record();
                $user_info_id = $dbbt->f("user_info_id");
                if( $user_info_id != $db->f("user_info_id")) {
                        // Get user's alternative shipping information
                        $dbst =& new ps_DB;
                        $qt = "SELECT * FROM #__{vm}_user_info WHERE user_info_id='".$db->f("user_info_id")."' AND address_type='ST'";
                        $dbst->query($qt);
			$dbst->next_record();
		}
		else {
			$dbst = $dbbt;
		}

		// PayJunction vars to send
		$formdata = array (
		'dc_logon' => PJ_LOGON,
		'dc_password' => PJ_PASSWORD,
		'dc_version' => '1.2',
		'dc_posture' => 'void',
		'dc_transaction_type' => 'update',
		'dc_transaction_id' => $db->f("order_payment_trans_id"),
		);

		//build the post string
		$poststring = '';
		foreach($formdata as $key => $val){
			$poststring .= urlencode($key) . "=" . urlencode($val) . "&";
		}
		// strip off trailing ampersand
		$poststring = substr($poststring, 0, -1);

		if( function_exists( "curl_init" )) {

			$CR = curl_init();
			curl_setopt($CR, CURLOPT_URL, "https://".$host.$path);
			curl_setopt($CR, CURLOPT_SSL_VERIFYPEER, 1);
			curl_setopt($CR, CURLOPT_SSL_VERIFYHOST, 2);
			curl_setopt($CR, CURLOPT_POST, 1);
			curl_setopt($CR, CURLOPT_POSTFIELDS, $poststring);
			curl_setopt($CR, CURLOPT_FOLLOWLOCATION, 0);
			curl_setopt($CR, CURLOPT_RETURNTRANSFER, 1);
			curl_setopt($CR, CURLOPT_FAILONERROR, true);

			$result = curl_exec( $CR );

			$error = curl_error( $CR );
			if( !empty( $error )) {
				$vmLogger->err( curl_error( $CR ) );
				$html = "<br/><span class=\"message\">".$VM_LANG->_PHPSHOP_PAYMENT_INTERNAL_ERROR." PayJunction.com</span>";
				return false;
			}
			else {
				//echo $result; exit();
			}
			curl_close( $CR );
		}
		else {

			$fp = fsockopen("ssl://".$host, $port, $errno, $errstr, $timeout = 60);
			if(!$fp){
				//error tell us
				$vmLogger->err("$errstr ($errno)");
			}
			else {

				//send the server request
				fputs($fp, "POST $path HTTP/1.1\r\n");
				fputs($fp, "Host: $host\r\n");
				fputs($fp, "Content-type: application/x-www-form-urlencoded\r\n");
				fputs($fp, "Content-length: ".strlen($poststring)."\r\n");
				fputs($fp, "Connection: close\r\n\r\n");
				fputs($fp, $poststring . "\r\n\r\n");

				//Get the response header from the server
				$str = '';
				while(!feof($fp) && !stristr($str, 'content-length')) {
					$str = fgets($fp, 4096);
				}
				// If didnt get content-lenght, something is wrong, return false.
				if (!stristr($str, 'content-length')) {
					return false;

				}
				$data = "";
				while (!feof($fp)) {
					$data .= fgets ($fp, 1024);
				}
				$result = trim( $data );
			}
		}
	
		// Parse the response from PayJunction
                $content = explode(chr(28), $result);
                foreach($content as $key_value) {
                	list($key,$value) = explode('=', $key_value);
                	$response[$key] = $value;
                }
                                
                $vmLogger->debug('Beginning to analyse the response from '.$host);
		
		// Approved - Success!
		if ($response['dc_query_status'] == 'true' && $response['dc_posture'] == 'void') {
			$d["order_payment_log"] = $VM_LANG->_PHPSHOP_PAYMENT_TRANSACTION_SUCCESS.": ".$response['dc_response_code'];

			$vmLogger->debug( $d['order_payment_log']);

			// Catch Transaction ID
			$d["order_payment_trans_id"] = $response['dc_transaction_id'];
			return True;
		}
		// Payment Declined
		else if ($response['dc_posture']=='capture') {
			if (PJ_SHOW_ERROR_CODE == 'YES') {
				$vmLogger->err('Could not update status.  Status is currently set to '.$reponse['dc_posture'].'.  Please refund the transaction manually at payjunction.com');
		   	} else {
           			$vmLogger->err('Could not update status.  Status is currently set to '.$reponse['dc_posture'].'.  Please refund the transaction manually at payjunction.com');
           		}

			$d["order_payment_log"] = $response['dc_response_message'];
			// Catch Transaction ID
			$d["order_payment_trans_id"] = $response['dc_transaction_id'];
			return False;
		}
		else if ($response['dc_query_status']) {
			if (PJ_SHOW_ERROR_CODE == 'YES') {
				$vmLogger->err('Could not update status.  Status is currently set to '.$reponse['dc_posture']);
		   	} else {
           			$vmLogger->err('Could not update status.  Status is currently set to '.$reponse['dc_posture']);
			}

			$d["order_payment_log"] = $response['dc_response_message'];
			// Catch Transaction ID
			$d["order_payment_trans_id"] = $response['dc_transaction_id'];
			return False;
		}
	}
	
	/**************************************************************************
	** name: refund_payjunction()
	** created by: Soeren
	** modified by: Alex Estrada, PayJunction, Inc.
	** description: Process a previous transaction with payjunction.com, Void the Payment
	** parameters: $order_number, the number of the order, we're processing here
	** returns:
	***************************************************************************/
	function refund_payment( &$d ) {
	
		global $vendor_mail, $vendor_currency, $VM_LANG, $vmLogger;

		$database = new ps_DB();

		if( empty($d['order_number'])) {
			$vmLogger->err("Error: No Order Number provided.");
			return false;
		}
		/*** Get the Configuration File for PayJunction ***/
		require_once(CLASSPATH ."payment/".$this->classname.".cfg.php");

		$host = 'www.payjunction.com';
		$port = 443;
		$path = "/quick_link";
		
		$db = new ps_DB;
		$q = "SELECT * FROM #__{vm}_orders, #__{vm}_order_payment WHERE ";
		$q .= "order_number='".$d['order_number']."' ";
		$q .= "AND #__{vm}_orders.order_id=#__{vm}_order_payment.order_id";
		$db->query( $q );
		if( !$db->next_record() ) {
			$vmLogger->err("Error: Order not found.");
			return false;
		}
		$expire_month = date( "m", $db->f("order_payment_expire") );
		$expire_year = date( "y", $db->f("order_payment_expire") );

		// DECODE Account Number
		$dbaccount = new ps_DB;
		$q = "SELECT DECODE(order_payment_number,'".ENCODE_KEY."')
          AS account_number from #__{vm}_order_payment WHERE order_id='".$db->f("order_id")."'";
		$dbaccount->query($q);
		$dbaccount->next_record();

		// Get user billing information
		$dbbt = new ps_DB;
		$qt = "SELECT * FROM #__{vm}_user_info WHERE user_id='".$db->f("user_id")."'";
		$dbbt->query($qt);
                $dbbt->next_record();
                $user_info_id = $dbbt->f("user_info_id");
                if( $user_info_id != $db->f("user_info_id")) {
                        // Get user's alternative shipping information
                        $dbst =& new ps_DB;
                        $qt = "SELECT * FROM #__{vm}_user_info WHERE user_info_id='".$db->f("user_info_id")."' AND address_type='ST'";
                        $dbst->query($qt);
			$dbst->next_record();
		}
		else {
			$dbst = $dbbt;
		}
 		// Setup dc_security string
 		if(PJ_CHECK_CARD_CODE=='YES') {
 			$cvv = 'M';
 		} else {
 			$cvv = 'I';
 		}
 		if(PJ_AVS=='OFF') {
 			$dc_security = "AWZ|$cvv|false|true|false";
 		} else {
 			$dc_security = PJ_AVS."|$cvv|false|false|false";
 		}
 		
		// PayJunction vars to send
		$formdata = array (
		'dc_logon' => PJ_LOGON,
		'dc_password' => PJ_PASSWORD,
		'dc_version' => '1.2',
		'dc_security' => $dc_security,

		// Customer Name and Billing Address
		'dc_first_name' => substr($dbbt->f("first_name"), 0, 50),
		'dc_last_name' => substr($dbbt->f("last_name"), 0, 50),
		'dc_company' => substr($dbbt->f("company"), 0, 50),
		'dc_address' => substr($dbbt->f("address_1"), 0, 60),
		'dc_city' => substr($dbbt->f("city"), 0, 40),
		'dc_state' => substr($dbbt->f("state"), 0, 40),
		'dc_zip' => substr($dbbt->f("zip"), 0, 20),
		'dc_country' => substr($dbbt->f("country"), 0, 60),
		'dc_phone' => substr($dbbt->f("phone_1"), 0, 25),
		'dc_fax' => substr($dbbt->f("fax"), 0, 25),

		// Customer Shipping Address
		'dc_shipping_first_name' => substr($dbst->f("first_name"), 0, 50),
		'dc_shipping_last_name' => substr($dbst->f("last_name"), 0, 50),
		'dc_shipping_company' => substr($dbst->f("company"), 0, 50),
		'dc_shipping_address' => substr($dbst->f("address_1"), 0, 60),
		'dc_shipping_city' => substr($dbst->f("city"), 0, 40),
		'dc_shipping_state' => substr($dbst->f("state"), 0, 40),
		'dc_shipping_zip' => substr($dbst->f("zip"), 0, 20),
		'dc_shipping_country' => substr($dbst->f("country"), 0, 60),

		// Invoice Information
		'dc_invoice_number' => substr($d['order_number'], 0, 20),
		'dc_notes' => '',

		// Transaction Data
		'dc_transaction_amount' => $db->f("order_total")-substr($db->f('order_tax'), 0, 15)-$db->f('order_shipping'),
		'dc_transaction_type' => 'CREDIT',

		'dc_transaction_id' => $db->f("order_payment_trans_id"),

		// Level 2 data
		'dc_tax_amount' => substr($db->f('order_tax'), 0, 15),
		'dc_shipping_amount' => $db->f('order_shipping'),

		);
		//build the post string
		$poststring = '';
		foreach($formdata as $key => $val){
			$poststring .= urlencode($key) . "=" . urlencode($val) . "&";
		}
		// strip off trailing ampersand
		$poststring = substr($poststring, 0, -1);

		if( function_exists( "curl_init" )) {

			$CR = curl_init();
			curl_setopt($CR, CURLOPT_URL, "https://".$host.$path);
			curl_setopt($CR, CURLOPT_SSL_VERIFYPEER, 1);
			curl_setopt($CR, CURLOPT_SSL_VERIFYHOST, 2);
			curl_setopt($CR, CURLOPT_POST, 1);
			curl_setopt($CR, CURLOPT_POSTFIELDS, $poststring);
			curl_setopt($CR, CURLOPT_FOLLOWLOCATION, 0);
			curl_setopt($CR, CURLOPT_RETURNTRANSFER, 1);
			curl_setopt($CR, CURLOPT_FAILONERROR, true);

			$result = curl_exec( $CR );

			$error = curl_error( $CR );
			if( !empty( $error )) {
				$vmLogger->err( curl_error( $CR ) );
				$html = "<br/><span class=\"message\">".$VM_LANG->_PHPSHOP_PAYMENT_INTERNAL_ERROR." PayJunction.com</span>";
				return false;
			}
			else {
				//echo $result; exit();
			}
			curl_close( $CR );
		}
		else {

			$fp = fsockopen("ssl://".$host, $port, $errno, $errstr, $timeout = 60);
			if(!$fp){
				//error tell us
				$vmLogger->err("$errstr ($errno)");
			}
			else {

				//send the server request
				fputs($fp, "POST $path HTTP/1.1\r\n");
				fputs($fp, "Host: $host\r\n");
				fputs($fp, "Content-type: application/x-www-form-urlencoded\r\n");
				fputs($fp, "Content-length: ".strlen($poststring)."\r\n");
				fputs($fp, "Connection: close\r\n\r\n");
				fputs($fp, $poststring . "\r\n\r\n");

				//Get the response header from the server
				$str = '';
				while(!feof($fp) && !stristr($str, 'content-length')) {
					$str = fgets($fp, 4096);
				}
				// If didnt get content-lenght, something is wrong, return false.
				if (!stristr($str, 'content-length')) {
					return false;

				}
				$data = "";
				while (!feof($fp)) {
					$data .= fgets ($fp, 1024);
				}
				$result = trim( $data );
			}
		}
	
		// Parse the response from PayJunction
                $content = explode(chr(28), $result);
                foreach($content as $key_value) {
                	list($key,$value) = explode('=', $key_value);
                	$response[$key] = $value;
                }
                                
                $vmLogger->debug('Beginning to analyse the response from '.$host);
		
		// Approved - Success!
		if ($response['dc_response_code'] == '00' || $response['dc_response_code'] == '85') {
			$d["order_payment_log"] = $VM_LANG->_PHPSHOP_PAYMENT_TRANSACTION_SUCCESS.": ".$response['dc_response_code'];

			$vmLogger->debug( $d['order_payment_log']);

			// Catch Transaction ID
			$d["order_payment_trans_id"] = $response['dc_transaction_id'];
			return True;
		}
		// Payment Declined
		else if ($response['dc_response_code']) {
			if (PJ_SHOW_ERROR_CODE == 'YES') {
				$vmLogger->err( $response['dc_response_code']."- ". $response['dc_response_message']);
		   	} else {
           			$vmLogger->err($response['dc_response_message']);
			}

			$d["order_payment_log"] = $response['dc_response_message'];
			// Catch Transaction ID
			$d["order_payment_trans_id"] = $response['dc_transaction_id'];
			return False;
		}
	}
}
